package PIANOS.datastructures;

import PIANOS.exceptions.*;
import java.util.HashMap;
import java.util.LinkedList;

public class Entity{

    private String name;
    private String dataFile;
    private String spatialMatrixFile;

    private boolean isMatrix;

    private int size;
    private int lineLength;

    private LinkedList<Variable> variableList;

    private Entity xCoordinate;
    private Entity yCoordinate;

    public Entity (){
	this.name = null;
	this.dataFile = null;
	this.spatialMatrixFile = null;
	this.isMatrix = false;
	this.size = -1;
	this.lineLength = -1;
	this.xCoordinate = null;
	this.yCoordinate = null;
	variableList = new LinkedList<Variable>();
    }

    public void addVariable (Variable variable){
	variableList.add(variable);
    }

    public LinkedList<Variable> getVariableList (){
	return this.variableList;
    }
    
    public String getName(){
	return this.name;
    }

    public void setName(String name) {
    	this.name=name;
    }

    public void setSize (int size){
	this.size = size;
    }

    public int getSize (){
	return this.size;
    }

    public void setLineLength (int lineLength){
	this.lineLength = lineLength;
    }

    public int getLineLength (){
	return this.lineLength;
    }

    public String getDataFile (){
	return this.dataFile;
    }
    
    public void setDataFile (String dataFile){
	this.dataFile = dataFile;
    }

    public boolean isMatrix (){
	return isMatrix;
    }
    
    public void setMatrix (boolean isMatrix){
	this.isMatrix=isMatrix;
    }

    public String getSpatialMatrixFile (){
	return spatialMatrixFile;
    }
    
    public void setSpatialMatrixFile (String spatialMatrixFile){
	this.spatialMatrixFile=spatialMatrixFile;
    }

    public Entity getXCoordinate (){
	return xCoordinate;
    }
    
    public void setXCoordinate (Entity xCoordinate){
	this.xCoordinate = xCoordinate;
    }

    public Entity getYCoordinate (){
	return yCoordinate;
    }
    
    public void setYCoordinate (Entity yCoordinate){
	this.yCoordinate = yCoordinate;
    }

    public boolean isSpatial (){
	if (this.spatialMatrixFile == null)
	    return false;
	else 
	    return true;
    }

    public String toString(){
	String toReturn = "";
	toReturn += "ENTITY " + this.getName();
	if (this.getDataFile() != null)
	    toReturn += " \"" + this.getDataFile() + "\"";
	
	if (this.isMatrix()){
	    toReturn += ", combines(" + this.getXCoordinate().getName();
	    toReturn += ", " + this.getYCoordinate().getName() + ")";
	    
	}
	else {
	    if (this.getSpatialMatrixFile() != null)
		toReturn += ", " + this.getSpatialMatrixFile();
	}
	toReturn += " size "+ this.getSize() + "\n";
	toReturn += "\tVariables: \n";

	for (Variable var : this.getVariableList()){
	    toReturn += "\t" + var + "\n";
	}
	return toReturn;
    }
}
